' Form  ListView 1ǉTvłB
Public Class Form1
    Dim objDiff As NonDiffNet.NonDiffClass  ' eLXgIuWFNg

    ' tH[[h
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' eLXgIuWFNg
        InitNonDiff()

        ' eLXgt@CǍ
        Dim strDt0 As String
        Dim strDt1 As String
        Dim AppPath As String = System.AppDomain.CurrentDomain.BaseDirectory
        strDt0 = TextRead(AppPath & "TestSJIS.txt")
        strDt1 = TextRead(AppPath & "TestUTF8.txt")

        ' eLXg
        Dim dfList(,) As String
        Dim blnNoSp As Boolean = False ' 󔒕rȂTrue
        dfList = objDiff.NonDiff(strDt0, strDt1, blnNoSp, 2, 1, 1, "file0", "file1")

        ' eLXg\
        DspDiffList(dfList)
    End Sub

    ' eLXgIuWFNg
    Private Sub InitNonDiff()
        objDiff = New NonDiffNet.NonDiffClass
    End Sub

    ' eLXg\
    Private Sub DspDiffList(ByRef dfList(,) As String)
        ' Xg
        ListInit()

        Dim i As Long
        For i = 1 To UBound(dfList, 2)
            ' \f[^ϊ(TAB̓Xy[Xɕϊ)
            Dim strDt(1) As String
            strDt(0) = Replace(dfList(2, i), vbTab, " ")
            strDt(1) = Replace(dfList(4, i), vbTab, " ")

            ' Xgݒ(\f[^ݒ)
            Dim dsp(6) As String
            dsp(1) = i
            dsp(2) = dfList(0, i)
            dsp(3) = dfList(1, i)
            dsp(4) = strDt(0)
            dsp(5) = strDt(1)
            dsp(6) = dfList(3, i)
            Dim item As ListViewItem = New ListViewItem(dsp)

            ' Xgݒ(wiFύX)
            If dsp(2) = "ADD" Then
                item.BackColor = System.Drawing.Color.Pink
            ElseIf dsp(2) = "DEL" Then
                item.BackColor = System.Drawing.Color.LightGray
            ElseIf dsp(2) = "UPD" Then
                item.BackColor = System.Drawing.Color.Cyan
            Else
                item.BackColor = System.Drawing.Color.White
            End If

            ' Xgݒ(sǉ)
            ListView1.Items.Add(item)
        Next
    End Sub

    ' eLXgt@CǍ
    Private Function TextRead(ByVal fpath As String) As String
        Dim sr As IO.Stream = Nothing
        Dim br As IO.BinaryReader = Nothing
        Try
            ' eLXgoCgzœǍ
            Dim bytCode() As Byte = New Byte(-1) {}
            sr = IO.File.Open(fpath, IO.FileMode.Open, IO.FileAccess.Read)
            br = New IO.BinaryReader(sr)
            bytCode = br.ReadBytes(sr.Length)

            ' R[h(blnBin=oCiL)
            Dim codeName As String
            codeName = objDiff.GetCodeName(bytCode, blnBin:=True)

            ' R[hϊ
            Select Case codeName
                Case "SJIS"
                    TextRead = objDiff.SJIS_To_VbUnicode(bytCode)
                Case "JIS"
                    TextRead = objDiff.JIS_To_VbUnicode(bytCode)
                Case "EUC"
                    TextRead = objDiff.EUC_To_VbUnicode(bytCode)
                Case "UNICODE"
                    TextRead = objDiff.UNICODE_To_VbUnicode(bytCode)
                Case "UTF7"
                    TextRead = objDiff.UTF7_To_VbUnicode(bytCode)
                Case "UTF8"
                    TextRead = objDiff.UTF8_To_VbUnicode(bytCode)
                Case "BIN"
                    TextRead = objDiff.SJIS_To_VbUnicode(bytCode)
                Case Else
                    TextRead = objDiff.SJIS_To_VbUnicode(bytCode)
            End Select
            Exit Function
        Catch ex As Exception
            Throw ex
        Finally
            If br Is Nothing = False Then br.Close()
            If sr Is Nothing = False Then sr.Close()
        End Try
    End Function

    ' Xg
    Private Sub ListInit()
        ListView1.Items.Clear()
        ListView1.FullRowSelect = True
        ListView1.GridLines = True
        ListView1.View = View.Details
        Dim columnDmy As ColumnHeader = New ColumnHeader
        Dim columnNo0 As ColumnHeader = New ColumnHeader
        Dim columnTyp As ColumnHeader = New ColumnHeader
        Dim columnNo1 As ColumnHeader = New ColumnHeader
        Dim columnFl1 As ColumnHeader = New ColumnHeader
        Dim columnFl2 As ColumnHeader = New ColumnHeader
        Dim columnNo2 As ColumnHeader = New ColumnHeader
        columnDmy.Width = 0
        columnNo0.Text = "No."
        columnNo0.Width = 45
        columnTyp.Text = ""
        columnTyp.Width = 45
        columnNo1.Text = "sNo."
        columnNo1.Width = 45
        columnFl1.Text = "t@CP"
        columnFl1.Width = 265
        columnFl2.Text = "t@CQ"
        columnFl2.Width = 265
        columnNo2.Text = "sNo."
        columnNo2.Width = 45
        Dim colHeaderRegValue() As ColumnHeader = _
          {columnDmy, columnNo0, columnTyp, columnNo1, columnFl1, columnFl2, columnNo2}
        ListView1.Columns.AddRange(colHeaderRegValue)
    End Sub
End Class
